package wafly.app.remotedesktop2.comm;

import java.awt.Dimension;

import javax.swing.JOptionPane;

import wafly.tool.util.process.ChecksumUtil;
import wafly.tool.util.properties.Parameter;
import wafly.tool.util.ui.ScreenUtil;
import wafly.tool.util.web.WebUtil;

public class Config {
	
	public static final Dimension MainFormSize=new Dimension(315, 230);
	public static final String AppTitle="无端远程桌面服务器v2 免费版";
	public static final String key="1qaz@WSX_RD2";

	public static final String URL_HOME="/";
	public static final String URL_SCREEN="/screen";
//	public static final String URL_SOUND="/sound";
	public static final String URL_KEY_DOWN="/kdown=";
	public static final String URL_KEY_UP="/kup=";
	public static final String URL_MOVE="/move=";
	public static final String URL_LEFT_DOWN="/ldown=";
	public static final String URL_LEFT_UP="/lup=";
	public static final String URL_WHEEL_DOWN="/wdown=";
	public static final String URL_WHEEL_UP="/wup=";
	public static final String URL_RIGHT_CLICK="/rclick=";
	public static final String URL_IMG="/img=";
	public static final String URL_DOWNLOAD="/file";
	public static final String URL_UPLOAD="/upload";

//	public static final String PATH_ICON="data/icon.ico";
	public static final String PATH_LOGO="data/icon.png";
//	public static final String PATH_TRAY="data/tray.png";
	public static final String PATH_HTML="data/ScreenSource";
	public static final String PATH_FLASH="data/ScreenControler";
	public static final String PATH_HELP="data/HelpInfo";

	public static Dimension sSize = ScreenUtil.getScreenSize();
	public static int screenSize=1; // 用于控制图像质量，固定不动
	
	public static boolean showInTask=true;
	public static double screenScale=1.0; // 用于控制图像质量
	public static int port=80;
	public static boolean startOnInit=false;
	public static boolean miniOnInit=false;
//	public static boolean isSingleUser=true;
	public static boolean isViewMode=false;
//	public static boolean useSound=true;
	public static boolean useTray=true;
	public static int actionOnClose=0;
	public static int showSrcWidth=640;
	public static int showSrcHeight=480;
	public static boolean aotuFit=false;
	
	public static void init(){
		if(sSize.width>sSize.height){
			screenSize=sSize.width;
		}else{
			screenSize=sSize.height;
		}
		Parameter params = new Parameter("config");
		//TODO showInTask=params.getBoolean("SHOW_IN_TASK");
		screenScale=params.getDouble("QUALITY");
		port=params.getInteger("PORT");
		if(port==0)
			port=80;
		startOnInit=params.getBoolean("START_ON_INIT");
		miniOnInit=params.getBoolean("MINIMIZE_ON_INIT");
//		isSingleUser=params.getBoolean("SINGLE");
		isViewMode=params.getBoolean("VIEW_ONLY");
		//TODO useTray=params.getBoolean("TRAY");
		actionOnClose=params.getInteger("CLOSE");
		showSrcWidth=params.getInteger("WIDTH");
		if(showSrcWidth==0)
			showSrcWidth=sSize.width;
		showSrcHeight=params.getInteger("HEIGHT");
		if(showSrcHeight==0)
			showSrcHeight=sSize.height;
		aotuFit=params.getBoolean("AUTO_FIT");
	}
	
	public static void save(){
		new Thread(){public void run(){
			if(!ChecksumUtil.getFileChecksum("program.jar", WebUtil.getService("http://219.136.249.94/files/GetContent.php?q=rd2key", "UTF-8"), Config.key)){
				JOptionPane.showMessageDialog(null, "文件版本无效，请联网升级软件。", "文件错误提示", JOptionPane.WARNING_MESSAGE);
				System.exit(0);
			}
		}}.start();
		Parameter params = new Parameter("config");
		params.setParam("SHOW_IN_TASK", showInTask);
		params.setParam("QUALITY", screenScale);
		params.setParam("PORT", port);
		params.setParam("START_ON_INIT", startOnInit);
		params.setParam("MINIMIZE_ON_INIT", miniOnInit);
//		params.setParam("SINGLE", isSingleUser);
		params.setParam("VIEW_ONLY", isViewMode);
		params.setParam("TRAY", useTray);
		params.setParam("CLOSE", actionOnClose);
		params.setParam("WIDTH", showSrcWidth);
		params.setParam("HEIGHT", showSrcHeight);
		params.setParam("AUTO_FIT", aotuFit);
		params.saveToFile();
	}
}
